﻿using UnityEngine;
using System.Collections;

public class inputstring : MonoBehaviour {
	
	public static inputstring Instance;
	
	public inputstring() {
			
	}
	
	public int[] inputchain = new int[100];
	
	public bool inputStringOpen = false;
	public int inputstringPosition = 0;
	
	public GameObject player;
	public GameObject leftDirection;
	public GameObject middleDirection;
	public GameObject rightDirection;
	public GameObject countdown;
	
	public bool nextLevelAlreadyLoaded = false;
	
	int jumpmodifier = 1; // idea: make this 10 when space is pressed. add to the next direction
	
	void Awake() {
		Instance = this;
	}
	
	// Use this for initialization
	void Start () {
		player = GameObject.Find("player");
		leftDirection = GameObject.Find("LeftDirection");
		middleDirection = GameObject.Find("MiddleDirection");
		rightDirection = GameObject.Find("RightDirection");
		countdown = GameObject.Find("Countdown");
		
		resetinputchain();
		
		leftDirection.GetComponent<UISprite>().spriteName = "empty";
		middleDirection.GetComponent<UISprite>().spriteName = "empty";
		rightDirection.GetComponent<UISprite>().spriteName = "empty";
	}
	
	public void startInput() {
		StartCoroutine(openTheInputString());
	}	
	
	void resetinputchain() {
		for(int i = 0; i < inputchain.Length; i++) {
			inputchain[i] = -1;	
		}
	}
	
	IEnumerator handleCountdown() {
		
		yield return new WaitForSeconds(1);
		countdown.GetComponent<UISlider>().sliderValue -= 0.1F;
		yield return new WaitForSeconds(1);
		countdown.GetComponent<UISlider>().sliderValue -= 0.1F;
		yield return new WaitForSeconds(1);
		countdown.GetComponent<UISlider>().sliderValue -= 0.1F;
		yield return new WaitForSeconds(1);
		countdown.GetComponent<UISlider>().sliderValue -= 0.1F;
		yield return new WaitForSeconds(1);
		countdown.GetComponent<UISlider>().sliderValue -= 0.1F;
		yield return new WaitForSeconds(1);
		countdown.GetComponent<UISlider>().sliderValue -= 0.1F;
		yield return new WaitForSeconds(1);
		countdown.GetComponent<UISlider>().sliderValue -= 0.1F;
		yield return new WaitForSeconds(1);
		countdown.GetComponent<UISlider>().sliderValue -= 0.1F;
		yield return new WaitForSeconds(1);
		countdown.GetComponent<UISlider>().sliderValue -= 0.1F;
		yield return new WaitForSeconds(1);
		//countdown.GetComponent<UISlider>().sliderValue -= 0.1F;
	}
	
	IEnumerator openTheInputString() {
		Debug.Log("open chain");
		inputStringOpen = true;
		inputstringPosition = 0;
		resetinputchain();
		StartCoroutine(handleCountdown());
		yield return new WaitForSeconds(10);
		inputStringOpen = false;
		Debug.Log("close chain");
		StartCoroutine(handleInputString());
		countdown.GetComponent<UISlider>().sliderValue = 1.0F;
	}
	
	string intToStringName(int a) {
		
		if(a == 1) {
			return "up";
		} else if(a == 2) {
			return "down";
		} else if(a == 3) {
			return "left";
		} else if(a == 4) {
			return "right";
		} else if(a == -1) {
			return "empty";	
		} else if(a == 10) {
			return "jumpUp";	
		} else if(a == 20) {
			return "jumpDown";	
		} else if(a == 30) {
			return "jumpleft";	
		} else if(a == 40) {
			return "jumpRight";	
		} else {
			return "error";
		}
		
	}
	
	void handleDirectionDisplay(int chainpos) {
		if(chainpos == 0) {
			leftDirection.GetComponent<UISprite>().spriteName = "empty";
			middleDirection.GetComponent<UISprite>().spriteName = intToStringName(inputchain[chainpos]);
			rightDirection.GetComponent<UISprite>().spriteName = intToStringName(inputchain[chainpos+1]);
		} else { 
			leftDirection.GetComponent<UISprite>().spriteName = intToStringName(inputchain[chainpos-1]);
			middleDirection.GetComponent<UISprite>().spriteName = intToStringName(inputchain[chainpos]);
			rightDirection.GetComponent<UISprite>().spriteName = intToStringName(inputchain[chainpos+1]);	
		}
	}
	
	void movePlayer(int j) {
		numbersToTrack.Instance.stepcount++;
		numbersToTrack.Instance.updateStatusLabel();
		if(inputchain[j] == 1) {
			//AudioController.Play("walking");
			Vector3 pos = player.transform.position;
			pos.y += 1;
			
			iTween.MoveTo(GameObject.Find("playergraphics"),iTween.Hash("position",pos,"time",0.5F,"easetype","linear"));
			
			
			player.transform.position = pos;
			
		} else if(inputchain[j] == 2) {
			Vector3 pos = player.transform.position;
			pos.y -= 1;
			player.transform.position = pos;
			iTween.MoveTo(GameObject.Find("playergraphics"),iTween.Hash("position",pos,"time",0.5F,"easetype","linear"));
		} else if(inputchain[j] == 3) {
			Vector3 pos = player.transform.position;
			pos.x -= 1;
			player.transform.position = pos;
			iTween.MoveTo(GameObject.Find("playergraphics"),iTween.Hash("position",pos,"time",0.5F,"easetype","linear"));
		} else if(inputchain[j] == 4) {
			Vector3 pos = player.transform.position;
			pos.x += 1;
			player.transform.position = pos;
			iTween.MoveTo(GameObject.Find("playergraphics"),iTween.Hash("position",pos,"time",0.5F,"easetype","linear"));
		}
		// jump
		if(inputchain[j] == 10) {
			//AudioController.Play("jumping");
			Vector3 pos = player.transform.position;
			pos.y += 2;
			player.transform.position = pos;
			iTween.MoveTo(GameObject.Find("playergraphics"),iTween.Hash("position",pos,"time",0.5F,"easetype","linear"));
		} else if(inputchain[j] == 20) {
			Vector3 pos = player.transform.position;
			pos.y -= 2;
			player.transform.position = pos;
			iTween.MoveTo(GameObject.Find("playergraphics"),iTween.Hash("position",pos,"time",0.5F,"easetype","linear"));
		} else if(inputchain[j] == 30) {
			Vector3 pos = player.transform.position;
			pos.x -= 2;
			player.transform.position = pos;
			iTween.MoveTo(GameObject.Find("playergraphics"),iTween.Hash("position",pos,"time",0.5F,"easetype","linear"));
		} else if(inputchain[j] == 40) {
			Vector3 pos = player.transform.position;
			pos.x += 2;
			player.transform.position = pos;
			iTween.MoveTo(GameObject.Find("playergraphics"),iTween.Hash("position",pos,"time",0.5F,"easetype","linear"));
		}
	}
	
	IEnumerator handleInputString() {
		
		yield return new WaitForSeconds(0);
		Debug.Log("handle input start");
		for(int j = 0; j < inputchain.Length; j++) {
			if(inputchain[j] != -1) {
				
				movePlayer(j);
				handleDirectionDisplay(j);
				yield return new WaitForSeconds(0.5F);
				
			} else {
				//yield return new WaitForSeconds(0.5F);
				//Debug.Log("end of commands");	
				//didReachEndOfInputString();
				//yield return new WaitForSeconds(0.5F);	
		
				Debug.Log("did reach end of input");
				yield return new WaitForSeconds(0.5F);
				//didReachEndOfInputString();
				levelmanager.Instance.loadLevel(levelmanager.Instance.currentLevel);
				break;
			}
			
		}
		
	}
	
	void didReachEndOfInputString() {
		Debug.Log(nextLevelAlreadyLoaded);
		if(!nextLevelAlreadyLoaded) {
			didNotReachGoal();
		} else {
			nextLevelAlreadyLoaded = false;	
		}
		
		
	}
	
	void didNotReachGoal() {
		Debug.Log("not reached goal");
		resetinputchain();
		//player.transform.position = GameObject.Find("start").transform.position;
		//iTween.MoveTo(GameObject.Find("playergraphics"),iTween.Hash("position",GameObject.Find("start").transform.position,"time",0.5F,"easetype","linear","oncompletetarget",gameObject,"oncomplete","aaa"));
		Debug.Log("bb");
		//numbersToTrack.Instance.deathcount++;
		//numbersToTrack.Instance.updateStatusLabel();
		//StartCoroutine(startCountDownAgain());
		
		
	}
	
	void aaa() {
		Debug.Log("aaa");
		StartCoroutine(startCountDownAgain());	
	}
	
	IEnumerator startCountDownAgain() {
		yield return new WaitForSeconds(0.5F);
		nextLevelAlreadyLoaded = true;
		resetinputchain();
		levelmanager.Instance.loadLevel(levelmanager.Instance.currentLevel);
		
		/*
		Debug.Log(levelmanager.Instance.currentLevel);
		if(levelmanager.Instance.currentLevel > 0) {
			inputstring.Instance.startInput();
			numbersToTrack.Instance.updateStatusLabel();	
		}
		*/
	}
	
	IEnumerator goalReached() {
		levelmanager.Instance.currentLevel++;
		nextLevelAlreadyLoaded = true;
		resetinputchain();
		//yield return new WaitForSeconds(0.5F);	
		
		Debug.Log("did reach goal");
		yield return new WaitForSeconds(0);
		//levelmanager.Instance.loadLevel(levelmanager.Instance.currentLevel);
		
		
	}
	
	void didReachGoal() {
		StartCoroutine(goalReached());
		/*Debug.Log("did reach goal");
		resetinputchain();
		levelmanager.Instance.loadLevel(levelmanager.Instance.currentLevel+1);
		levelmanager.Instance.currentLevel++;
		nextLevelAlreadyLoaded = true;
		*/
	}
	
	void OnCollisionEnter(Collision collision) {
		//Debug.Log(collision.collider.gameObject.name);	
		if(collision.collider.gameObject.name.Equals("floor")) {
			// all good	
		} else if(collision.collider.gameObject.name.Equals("wall")) {
			Debug.Log("omg wall " + collision.collider.gameObject.name);	
			didNotReachGoal();
			AudioController.Play("wall");
		} else if(collision.collider.gameObject.name.Equals("goal")) {
			Debug.Log("omg goal");	
			didReachGoal();
			AudioController.Play("goal");
		} else if(collision.collider.gameObject.name.Equals("pit")) {
			Debug.Log("omg pit");	
			didNotReachGoal();
			AudioController.Play("pit");
		} else if(collision.collider.gameObject.name.Equals("wall1")) {
			Debug.Log("omg wall " + collision.collider.gameObject.name);	
			didNotReachGoal();
		} else if(collision.collider.gameObject.name.Equals("wall2")) {
			Debug.Log("omg wall " + collision.collider.gameObject.name);	
			didNotReachGoal();
		} else if(collision.collider.gameObject.name.Equals("wall3")) {
			Debug.Log("omg wall " + collision.collider.gameObject.name);	
			didNotReachGoal();
		} else if(collision.collider.gameObject.name.Equals("wall4")) {
			Debug.Log("omg wall " + collision.collider.gameObject.name);	
			didNotReachGoal();
		} else if(collision.collider.gameObject.name.Equals("wall5")) {
			Debug.Log("omg wall " + collision.collider.gameObject.name);	
			didNotReachGoal();
		} else if(collision.collider.gameObject.name.Equals("wall6")) {
			Debug.Log("omg wall " + collision.collider.gameObject.name);	
			didNotReachGoal();
		} else if(collision.collider.gameObject.name.Equals("wall7")) {
			Debug.Log("omg wall " + collision.collider.gameObject.name);	
			didNotReachGoal();
		}
		
	}
	
	// Update is called once per frame
	void Update () {
		if(inputStringOpen) {
			if(Input.GetKeyDown("up")) {
				inputchain[inputstringPosition] = 1*jumpmodifier;
				inputstringPosition++;
				if(jumpmodifier > 1) {
					jumpmodifier = 1;	
				}
			}
			
			if(Input.GetKeyDown("down")) {
				inputchain[inputstringPosition] = 2*jumpmodifier;
				inputstringPosition++;
				if(jumpmodifier > 1) {
					jumpmodifier = 1;	
				}
			}
			
			if(Input.GetKeyDown("left")) {
				inputchain[inputstringPosition] = 3*jumpmodifier;
				inputstringPosition++;
				if(jumpmodifier > 1) {
					jumpmodifier = 1;	
				}
			}
			
			if(Input.GetKeyDown("right")) {
				inputchain[inputstringPosition] = 4*jumpmodifier;
				inputstringPosition++;
				if(jumpmodifier > 1) {
					jumpmodifier = 1;	
				}
			}
			
			if(Input.GetKeyDown("space")) {
				jumpmodifier = 10;
				//inputchain[inputstringPosition] = 4;
				//inputstringPosition++;
			}
		}
	}
}
